#!node
var ckup, o, files, fs;
ckup = require('./ckup');
o = require('coco/optparse')({
  print: 'write to stdout instead of .htm',
  stdin: 'read stdin, then write to the given file or stdout',
  eval: 'read arguments as source',
  watch: 'watch and rerender on changes',
  css: 'render as ccss',
  version: 'show version',
  help: 'show me'
});
if (o.version) {
  v();
}
if (o.help) {
  h();
}
files = o.$args;
fs = require('fs');
(function(){
  var file, _i, _ref, _len;
  if (o.stdin) {
    return listen();
  }
  if (o.eval) {
    return render(files.join('\n'));
  }
  for (_i = 0, _len = (_ref = files).length; _i < _len; ++_i) {
    file = _ref[_i];
    render(fs.readFileSync(file, 'utf8'), file);
    if (o.watch) {
      watch(file);
    }
  }
  if (file || o.version || o.help) {
    return;
  }
  h(v());
  console.log('\nlistening to stdin...');
  listen();
}());
function render(code, name, asis){
  var kup;
  kup = ckup.render(o.css ? '<- (~> @_ = css it)\n' + code : code);
  if (!name || o.print) {
    return console.log('%s', kup);
  }
  if (!asis) {
    if (/\.\w+\.co$/i.test(name)) {
      name = name.slice(0, -3);
    } else {
      name = name.replace(/(?:\.\w+)?$/, (o.css ? '.css' : '.htm'));
    }
  }
  fs.writeFileSync(name, kup);
  return require('util').log(name);
}
function listen(){
  var code, stdin;
  code = '';
  stdin = process.openStdin();
  stdin.on('data', function(it){
    return code += it;
  });
  return stdin.on('end', function(){
    return render(code, files[0], true);
  });
}
function watch(file){
  return fs.watchFile(file, {
    persistent: true,
    interval: 500
  }, function(curr, prev){
    if (curr.size === prev.size && +curr.mtime === +prev.mtime) {
      return;
    }
    try {
      return render(fs.readFileSync(file, 'utf8'), file);
    } catch (e) {
      return console.error(e != null ? e.stack : void 8) || e;
    }
  });
}
function v(){
  return console.log('ckup ' + ckup.VERSION);
}
function h(){
  return console.log('Usage: ckup [options] [files]\n%s', o);
}